	SUBROUTINE ND_GGDS ( gdsarr, cprj, kx, ky, grdout, rnvblk,
     +			    iret )
C************************************************************************
C* ND_GGDS								*
C*									*
C* This subroutine takes the GDS information and constructs a 		*
C* navigation block for a GEMPAK grid file.				*
C*									*
C* ND_GGDS ( GDSARR, CPRJ, KX, KY, GRDOUT, RNVBLK, IRET )		*
C*									*
C* Input parameters:							*
C*	GDSARR (10)	REAL		GRIB GDS projection info	*
C*									*
C* Output parameters:							*
C*	CPRJ		CHAR*		Grid projection			*
C*	KX		INTEGER		Number of points in x dir	*
C*	KY		INTEGER		Number of points in y dir	*
C*	GRDOUT  (4)	REAL		Grid corners			*
C*	RNVBLK  (13)	REAL		Grid navigation block		*
C*	IRET		INTEGER		Return code			*
C*					  0 = normal return		*
C*					 -4 = invalid navigation	*
C**									*
C* Log:									*
C* T. Piper/SAIC	10/02	Modified from NAGGDS for GRIB2		*
C************************************************************************
	REAL		gdsarr (*), grdout (*), rnvblk (*)
	CHARACTER*(*)	cprj
C*
	LOGICAL		angflg
C------------------------------------------------------------------------
	iret = 0
C
C*	Set the projection.
C
	IF  ( NINT ( gdsarr (1) ) .eq. 0 )  THEN
	    cprj = 'CED'
	ELSE IF  ( NINT ( gdsarr (1) ) .eq. 10 )  THEN
	    cprj = 'MER'
	ELSE IF  ( NINT ( gdsarr (1) ) .eq. 20 )  THEN
	    cprj = 'STR'
	ELSE IF  ( NINT ( gdsarr (1) ) .eq. 30 )  THEN
	    cprj = 'LCC'
	ELSE
	    iret = -4
	    RETURN
	END IF
C
C*	Set the number of columns and rows.
	kx = NINT ( gdsarr (2) )
	ky = NINT ( gdsarr (3) )
C
C*	Set the lat/lon values of the corners.
C
	grdout (1) = gdsarr (4)
	grdout (2) = gdsarr (5)
	grdout (3) = gdsarr (6)
	grdout (4) = gdsarr (7)
C
C*	Set the projection angles.
C
	angle1 = gdsarr ( 8)
	angle2 = gdsarr ( 9)
	angle3 = gdsarr (10)
	angflg = .true.
C
C*	Fill navigation block.
C
	CALL GR_MNAV  ( cprj, kx, ky, grdout (1), grdout (2),
     +			grdout (3), grdout (4), angle1, angle2,
     +			angle3, angflg, rnvblk, ier )
C*
	RETURN
	END

	SUBROUTINE ND_GTBL  ( cpyfil, name, proj, nxgd, nygd, garea,
     +			     rnvblk, anlblk, iret )
C************************************************************************
C* ND_GTBL								*
C*									*
C* This subroutine finds grid INNAME (a numerical or character          *
C* identifier prefaced by '#') in a grid navigation table, then makes 	*
C* the navigation and analysis blocks.  The grid navigation is set up	*
C* in GEMPLT in order to check its validity.				*
C*									*
C* ND_GTBL  ( CPYFIL, NAME, PROJ, NXGD, NYGD, GAREA, RNVBLK, ANLBLK,	*
C*           IRET )							*
C*									*
C* Input parameters:							*
C*	CPYFIL		CHAR*		Input for CPYFIL		*
C*									*
C* Output parameters:							*
C*	NAME		CHAR*           Name of selected grid		*
C*	PROJ		CHAR*		Grid projection			*
C*	NXGD		INTEGER		Number of points in x dir	*
C*	NYGD		INTEGER		Number of points in y dir	*
C*	GAREA   (4)	REAL		Grid corners			*
C*	RNVBLK (LLNNAV)	REAL		Grid navigation block		*
C*	ANLBLK (LLNANL)	REAL		Grid analysis block		*
C*	IRET		INTEGER		Return code			*
C*					 +1 = EXIT entered		*
C*					  0 = normal return		*
C*					 -4 = invalid navigation	*
C*					 -9 = grid not found in table	*
C**									*
C* Log:									*
C* S. Jacobs/EAI	 7/93		Copied from GDCTBL		*
C* D. Keiser/GSC	12/95		Changed FL_TOPN to FL_TBOP	*
C************************************************************************
	INCLUDE		'GEMPRM.PRM'
C*
	CHARACTER*(*)	cpyfil, proj, name
	REAL		garea (*), rnvblk (*), anlblk (*)
C*
	CHARACTER	gntrec*80, namgd*4, c2name*8
	REAL		anggd (3), dbnds (4)
	INTEGER		iebnds (4)
	LOGICAL		found
C------------------------------------------------------------------------
	iret = 0
	name = ' '
C
C*	Get the grid number (INGRDN) out of NAME; a conversion error
C*	sets IERNUM .ne. 0 and it is assumed that NAME is a type.
C
	CALL ST_LCUC  ( cpyfil, c2name, ier )
	name = c2name ( 2: )
	CALL ST_NUMB  ( name, ingrdn, iernum )
C
C*	Open the table of valid grid types.
C
	CALL FL_TBOP  ( 'grdnav.tbl', 'grid', lungrd, ier )
	IF  ( ier .ne. 0 )  THEN
	    CALL ER_WMSG  ( 'FL', ier, 'grdnav.tbl', ier1 )
	    iret = -9
	    RETURN
	END IF
C
C*	List the table contents for the user, if requested.
C
	IF  ( name .eq. 'LIST' )  THEN
	    iostat = 0
	    DO WHILE  ( iostat .eq. 0 )
		READ  ( lungrd, 1000, iostat=iostat )  gntrec
1000		FORMAT ( A )
		WRITE  (6,*)  gntrec(1:79)
	    END DO
C
C*	    Rewind the table file.
C
	    CALL FL_TREW ( lungrd, ier )
C
C*	    Prompt user for grid choice.
C
	    CALL TM_CHAR  ( 'Enter grid id or number', .false.,
     +			     .false., 1, name, n, iret )
	    IF  ( iret .ne. 0 )  THEN
		iret = +1
		RETURN
	    END IF
	    CALL ST_LCUC  ( name, name, ier )
	    CALL ST_NUMB  ( name, ingrdn, iernum )
	END IF
C
C*	Read through the list of valid grid types/numbers to get 
C*	navigation/analysis information.
C
	found = .false.
	DO  WHILE  ( ( .not. found ) .and. ( ier .eq. 0 ) )
	    CALL TB_GRNV  ( lungrd, namgd, numgd, proj, anggd, garea,
     +			    nxgd, nygd, deln, extnd, ier )
	    IF  (( name .eq. namgd ) .or. ( ingrdn .eq. numgd ) ) THEN
     		found = .true.
	    END IF
	END DO
C*
	CALL FL_CLOS  ( lungrd, ier )
C
C*	Bail out if NAME wasn't found in the table.
C
	IF  ( .not. found )  THEN
	    CALL ER_WMSG  ( 'TB', ier, ' ', ier1 )
	    iret = -9
	    RETURN
	END IF
C
C*	Fill navigation block.
C
	CALL GR_MNAV  ( proj, nxgd, nygd, garea (1), garea (2),
     +			garea (3), garea (4), anggd (1), anggd (2),
     +			anggd (3), .true., rnvblk, ier )
C
C*	Set up navigation in GEMPLT to check validity.
C
	CALL GR_SNAV  ( 13, rnvblk, ier )
	IF  ( ier .ne. 0 )  THEN
	    iret = -4
	    RETURN
	END IF
C
C*	Make an analysis block.
C
	DO  i = 1, 4
	    iebnds (i) = extnd
	END DO
	DO  i = 1, 4
	    dbnds (i) = RMISSD
	END DO
	CALL GR_MBN2  ( deln, iebnds, dbnds, rnvblk, anlblk, ier )
C*
	RETURN
	END

	SUBROUTINE ND_WLCL (idat, gdattm, iret)
	
C************************************************************************
C* ND_WLCL								*
C*									*
C* This subroutine writes out the local section (Section 2) into a text *
C* file from a grib2 message.						*
C*									*
C* ND_WLCL (IDAT, GDATTM, IRET)						*
C*									*
C* Input Parameters:							*
C* 	IDAT (NIDAT)	INTEGER		Local Section			*
C*	GDATTM (2)	CHAR*		Grib message time		*
C*									*
C* Output Parameters:							*
C*	IRET		INTEGER		Return code			*
C**									*
C* Log:									*
C* C. Bailey		6/04	creation into subroutine		*
C************************************************************************
	INTEGER idat (*), numlines, numchars, iret
	CHARACTER line(1000)*300, gdattm(2)*(*), lclfile*128
C------------------------------------------------------------------------
	iret = 0

	numlines = 1
	numchars = 1
	
C Intialize strings

	do x = 1, 1000, 1
	    do y = 1, 300, 1
	        line(x)(y:y) = ' '	
	    end do
	end do
                
C DECODE EACH INTEGER VALUE INTO A CHARACTER AND ADD TO STRING
		 
	do 100 i = 3, idat(1)+2, 1
	    if( idat(i) .eq. 0) then 
C                NEW LINE	    
	         numlines = numlines + 1
	         numchars = 1
            else
	         line(numlines)(numchars:numchars) = CHAR(idat(i))
	         numchars = numchars + 1
	    endif
 100  	continue
 
        lclfile="local_"//gdattm(1)(1:6)//gdattm(1)(8:15)//".txt"   
            
        OPEN (1, file=lclfile)
        
	DO i=0, numlines-1, 1	 
            write(1,40) i, " = ", line(i+1)
 40         format(i3, a3, a300)
 	END DO
 	
        CLOSE (1)      
       
        RETURN
        
        END

	SUBROUTINE NDGINP  ( gbfile, gdoutf, maxgrd, garea, 
     +				gskip, output, overwr, gparm, iret )
C************************************************************************
C* NDGINP								*
C*									*
C* This subroutine gets the input parameters for NDFDG2.		*
C*									*
C* NDGINP ( GBFILE, GDOUTF, MAXGRD, GAREA, GSKIP, OUTPUT, GPARM, IRET )	*
C**									*
C* Log:									*
C* T. Piper/SAIC	10/02	Modified from NAGINP			*
C* T. Piper/SAIC	04/03	Added gskip				*
C************************************************************************
	CHARACTER*(*)	gbfile, gdoutf,	maxgrd, garea, gskip, output,
     +                  gparm
	LOGICAL         overwr
C------------------------------------------------------------------------
	iret = 0
	CALL IP_STR  ( 'GBFILE',  gbfile,  ier1 )
	CALL IP_STR  ( 'GDOUTF',  gdoutf,  ier2 )
	CALL IP_STR  ( 'MAXGRD',  maxgrd,  ier3 )
	CALL IP_STR  ( 'GAREA',   garea,   ier4 )
	CALL IP_STR  ( 'GSKIP',   gskip,   ier5 )
	CALL IP_STR  ( 'OUTPUT',  output,  ier6 )
	CALL IP_LOG  ( 'OVERWR',  overwr,  ier7 )
	CALL IP_STR  ( 'GPARM',   gparm,   ier8 )
C
	iret = ier1 + ier2 + ier3 + ier4 + ier5 + ier6 + ier7 + ier8
	IF  ( iret .ne. 0 )  iret = -2
C*
	RETURN
	END

	SUBROUTINE ND_PARM ( discpln, pds, parm, ihzrmp, idrct, iret )
C************************************************************************
C* ND_PARM								*
C*									*
C* This subroutine converts the GRIB2 discipline, parameter category, 	*
C* parameter number, and product definition template number into the 	*
C* four-character GEMPAK parameter name.				*
C*									*
C* ND_PARM  ( DISCPLN, PDS, PARM, IHZRMP, IDRCT, IRET )			*
C*									*
C* Input parameters:                                                    *
C*	DISCPLN		INTEGER		GRIB2 Master Table Number	*
C*      PDS(*)	     	INTEGER         GRIB2 PDS information		*
C*									*
C* Output parameters:                                                   *
C*      PARM(4)         CHAR*           GEMPAK parameter name           *
C*	IHZRMP		INTEGER		Horizontal remapping		*
C*	IDRCT		INTEGER		Directional flag		*
C*      IRET            INTEGER         Return code                     *
C*                                        0 = normal return             *
C*                                       +4 = invalid parm category     *
C**									*
C* Log:									*
C* T. Piper/SAIC        10/02   Created					*
C* T. Piper/SAIC	12/02	Added SNOW				*
C* T. Piper/SAIC	05/03	Rewrote to get from table		*
C* T. Piper/SAIC	08/03	Added CPC support			*
C* T. Piper/SAIC	10/03	Fixed bug with Probability of Precip.	*
C* M. Li/SAIC		04/04	Added ihzrmp, and idrct			*
C************************************************************************
	INTEGER       discpln, pds(*) 
	CHARACTER*(*) parm
	CHARACTER   chh*2, rrr*3, lparm*12
C-------------------------------------------------------------------
C*	If template 9, could be CPC product
	IF ( pds(8) .eq. 9 .and. pds(35) .ne. 255 )  THEN
	   ipdtn = (pds(35) * 10) + pds(8)
	ELSE
	   ipdtn = pds(8)
	END IF
 	CALL CTB_G2GNAM(discpln, pds(10), pds(11), ipdtn, lparm,
     +			ihzrmp, idrct, ier)
	IF ( ier .eq. 0 )  THEN
	    iret = 0
	    CALL ST_RNUL ( lparm, lparm, lenp, ier )
	    ipos = INDEX(lparm, "--")
	    IF ( ipos .ne. 0 )  THEN
		IF ( pds(8) .eq. 8 )  THEN
		    indx = 49
		ELSE IF ( pds(8) .eq. 9 )  THEN
		   indx = 62
		END IF
C*	Average, accumulation, and/or extreme values ...
		irange = pds(indx+1)
C*	Length of the time range over which statistical processing is done
C*	Indicator of unit of time range over which statistical processing is 
C*	done (See Code Table 4.4)
		IF ( pds(indx) .eq. 0 )  THEN
		    ihh = irange / 60
		ELSE IF ( pds(indx) .eq. 1 )  THEN
		    ihh = irange
		ELSE IF ( pds(indx) .eq. 2 )  THEN
		    ihh = irange * 24 
		ELSE IF ( pds(indx) .eq. 10 )  THEN
		    ihh = irange * 3
		ELSE IF ( pds(indx) .eq. 11 )  THEN
		    ihh = irange * 6
		ELSE IF ( pds(indx) .eq. 12 )  THEN
		    ihh = irange * 12
		ELSE IF ( pds(indx) .eq. 13 )  THEN
		    ihh = irange / 3600
		ELSE
		    ihh = 0
		END IF
		CALL ST_INCH(ihh+100, rrr, ier)
		chh = rrr(2:3)
		parm = lparm(1:ipos-1) // chh // lparm(ipos+2:lenp)
	    ELSE
	        parm = lparm
	    END IF
C*	Non-Supported Parameter Category
	ELSE
	    iret = +4 
	END IF
C
	RETURN
	END

	PROGRAM NDFDG2N
C************************************************************************
C* NDFDG2								*
C*									*
C* This program will convert GRIB2 grid data to GEMPAK grid data.	*
C*									*
C**									*
C* Log:									*
C* T. Piper/SAIC	10/02	Created from NAGRIB			*
C* K. Brill/HPC		11/02	Use LLMXTG to set MXGRIB parameter	*
C* T. Piper/SAIC	02/03	Fixed missing data for entire grid	*
C* T. Piper/SAIC	04/03	Added nd_gds and gskip parameter	*
C* T. Piper/SAIC	04/03	Replaced NAGCOG with ND_GCOG		*
C* T. Piper/SAIC	04/03	Increased MXGRIB for 2.5 km grids	*
C* T. Piper/SAIC	04/03	Added MXGRIB parameter to GB_READ	*
C* T. Piper/SAIC	05/03	Added CTB_G2READ			*
C* T. Piper/SAIC	05/03	Replaced GR_WNMC with GR_WGB2		*
C* T. Piper/SAIC	05/03	Increased NPDS to accommodate Template 9*
C* T. Piper/SAIC	08/03	Added CPC support			*
C* M. Li/SAIC		04/04	Added ihzrmp, and idrct			*
C* C. Bailey/HPC	06/04	Added missing parameter error statement	*
C************************************************************************
	INCLUDE		'GEMPRM.PRM'
C
	CHARACTER	gbfile*(LLMXLN), gdoutf*(LLMXLN), maxgrd*(LLMXLN),
     +			garea*(LLMXLN),  gskip*(LLMXLN),  output*(LLMXLN),
     +			gparm*(LLMXLN), indxfl*1, proj*1, grdarea*1, 
     +                  kxky*1, cpyfil*3
C
	CHARACTER	gdotmp*72, gprm*(LLMXLN)
C
	INTEGER		lun (MMFILE), ighdr (LLGDHD),
     +			jtime (3), level (2), ksbx (2), ksby (2)
	REAL		rnvblk (LLNNAV), gdsarr (10)
	CHARACTER	devs (MMFILE)*1, parm*12, gdattm (2)*20,
     +			tmpprm*10, vparm*4, cprj*24, errmsg*128
	LOGICAL		respnd, done, proces, cont, lstflg, prttl,
     +			trape0, subset
     
        character       filename*50
C
C*  GRIB2 variables
C
	PARAMETER ( MXGRIB = 3000000 )
	PARAMETER ( ND5   = MXGRIB )
	PARAMETER ( NIDAT = 50000 )
	PARAMETER ( NRDAT = 50000 )
	PARAMETER ( NDJER = 15 )
	PARAMETER ( NS0 = 16, NS1 = 21, NS2 = 10, NS3 = 96 )
	PARAMETER ( NPDS = 72, NS5 = 49, NS6 = 8, NS7 = 10 )
	PARAMETER ( NEXP = 12)

	REAL     grid(MXGRIB), rdat(NRDAT), xmissp, xmisss
	INTEGER igrid(MXGRIB), idat(NIDAT), ib(MXGRIB)
	INTEGER ipack(ND5), jer(NDJER, 2), kjer, num
	INTEGER is0(NS0), is1(NS1), is2(NS2), gds(NS3),
     +	  pds(NPDS), is5(NS5), is6(NS6), is7(NS7)
	LOGICAL big, unpk_endian, write_local
	CHARACTER*12 gprmarr(NEXP)
C
	DATA ipack / ND5*0 /
C
C*	Added common to prevent Stack Over Flow	(SOF)
C
	COMMON/NOSOF/igrid, grid, ib
C------------------------------------------------------------------------
	indxfl = ' '
	lenidx = 0
	proj = ' '
	grdarea = ' '
	kxky = ' '
	cpyfil = 'gds'
C
	kfildo = 6
	new = 1
	iclean = 0
	l3264b = 32
	xmissp = RMISSD
C
C*	Initialize TAE and GEMPLT
C
	CALL IP_INIT ( respnd, iperr )
	IF  ( iperr .eq. 0 )  THEN
	    CALL GG_INIT ( 1, iperr )
	END IF
	CALL IP_IDNT ( 'NDFDG2N', ier )
	IF  ( iperr .eq. 0 )  THEN
	    done = .false.
	ELSE
	    done = .true.
	END IF
	
C
C*	Initialize GRIB2 parameter table
C
	CALL CTB_G2READ (iret)
	IF  ( iret .ne. 0 )  THEN
	    done = .true.
	END IF
C
C*	Process grids until the user is finished.
C
	DO WHILE ( .not. done )
C
C*	    Get the user input.
C
	    CALL NDGINP ( gbfile, gdoutf, maxgrd, garea, gskip, 
     +						output, gparm, iperr )
	    IF  ( iperr .ne. 0 )  THEN
		done   = .true.
		proces = .false.
	    ELSE
		proces = .true.
	    END IF
	   
C
	    IF  ( proces )  THEN
C
C*		Process the user's input values
C
C*		GBFILE:  Open the GRIB file.
C               find length of string
		CALL ST_LSTR ( gbfile, lenfil, ier )
c               open grib file and index
		CALL GB_OPEN ( gbfile, lenfil, indxfl, lenidx, iret )
		IF  ( iret .ne. 0 )  THEN
		    CALL ER_WMSG ( 'NDFDG2', iret, ' ', ier )
		    proces = .false.
		END IF
		IF  ( proces )  THEN
		    igdfln = 0
C
C*		GDOUTF:  Check if user only wants a list
C                   convert lowercase to uppercase
		    CALL ST_LCUC ( gdoutf, gdotmp, iret )
		    IF  ( gdotmp .eq. 'LIST' )  THEN
			lstflg = .true.
		    ELSE
			lstflg = .false.
		    END IF
C
C*		MAXGRD:  Set the maximum number of grids from the user input.
C                   convert string to integer
		    CALL ST_NUMB ( maxgrd, maxg, ier )
		    IF ( maxg .gt. MMHDRS-1 )  THEN
			IF ( nlun .gt. 0 )  THEN
			    DO  ii = 1, nlun
				ilun = lun(ii)
				WRITE ( ilun, * )
     +				' WARNING : Resetting MAXGRD value'//
     +				' to maximum limit (', MMHDRS-1, ').'
			    END DO
			END IF
			maxg = MMHDRS-1
		    END IF
C
C*		GSKIP:  Convert to an integer
C
		    CALL ST_NUMB ( gskip, iskip, ier )
		    IF ( iskip .lt. 0 ) iskip = 0
C
C*		OUTPUT:  Set the output devices.
C
		    CALL IN_OUTT ( output, 'NDFDG2', lun, nlun, devs, ierr )
		    IF  ( ierr .ne. 0 )  nlun = 0
		  
C		GPARM: Input parameter to compare
                    CALL ST_LCUC ( gparm, gprm, ier )
                    CALL ST_C2C (gprm, nexp, gprmarr, num, iret)
C
C*		Read in grids to be processed until the end of file.
C
		    knt = 0
		    kntmsg = 0
		    trape0 = .false.
		END IF

C Read in GRIB Messages until the GEMPAK grid file reaches the specified
C maximum grids in file or an error occurs
		
		DO WHILE  ( proces .and. ( knt .lt. maxg ) )
C
		    kntmsg = kntmsg + 1
C
C*		    Set the start byte of the next GRIB message.  If the
C*		    end of the file has been reached stop processing.
C
		    CALL GB_NEXT ( iedtn, iret )
C
C*		    Check the GRIB edition.  Currently, only set the
C*		    return code to +5.  Decide later whether or not to
C*		    decode GRIB 0.
C
		    IF  ( iedtn .eq. 0 )  THEN
			IF  ( .not. trape0 )  THEN
			    CALL ER_WMSG ( 'NDFDG2', iret, ' ', ier )
			    trape0 = .true.
			END IF
		    END IF
C
C*		    Determine if the program should continue or not.
C
		    IF  ( iret .lt. 0 )  THEN
			proces = .false.
		    ELSE IF  ( iret .gt. 0 )  THEN
			proces = .true.
			cont   = .false.
		    ELSE
			proces = .true.
			cont   = .true.
		    END IF
C
C*		    If there is a next grid, continue processing.
C
		    IF  ( proces )  THEN
C
C*			Unpack the GRIB2 file.
C
			IF  ( cont )  THEN
			    CALL GB_READ ( MXGRIB, ipack, iret )
			    IF  ( iret .lt. 0 )  THEN
				CALL ER_WMSG ( 'NDFDG2', iret, ' ', ier )
				proces = .false.
				cont   = .false.
			    ELSE IF  ( iret .gt. 0 )  THEN
				CALL ER_WMSG ( 'NDFDG2', iret, ' ', ier )
				cont   = .false.
			    END IF
			END IF
			IF ( cont )  THEN
			    big = UNPK_ENDIAN()
			    IF ( .not. big ) THEN
				CALL MV_SWP4(ND5, ipack, ipack)
			    END IF
			    
c Call unpk_grib2 fuction from mdl library

			    CALL UNPK_GRIB2 ( kfildo, grid, igrid,
     +				    MXGRIB, idat, NIDAT, rdat,
     +				    NRDAT, is0, NS0, is1, NS1,
     +				    is2, NS2, gds, NS3, pds, NPDS,
     +				    is5, NS5, is6, NS6, is7, NS7,
     +				    ib, ibitmap, ipack, ND5, xmissp,
     +				    xmisss, new, iclean, l3264b,
     +				    iendpk, jer, NDJER, kjer )
C
			    IF ( jer(kjer,2) .eq. 1 )  THEN
				CALL ST_INCH ( jer(kjer,1), tmpprm, ier )
				CALL ER_WMSG ( 'NDFDG2', 3, tmpprm, ier )
			    ELSE IF ( jer(kjer,2) .eq. 2 )  THEN
				CALL ST_INCH ( jer(kjer,1), tmpprm, ier )
				CALL ER_WMSG ( 'NDFDG2', -9, tmpprm, ier )
				cont = .false.
			    END IF
			END IF
			
C
C*	SECTION 0 - INDICATOR SECTION
C
			IF  ( cont )  THEN
			    IF ( is0(7) .ne. 0 ) THEN
				CALL ST_INCH ( is0(7), tmpprm, ier )
				CALL ER_WMSG ( 'NDFDG2', -13, tmpprm, ier )
				cont = .false.
			    END IF
			END IF
C
C*	SECTION 1 - IDENTIFICATION SECTION
C
			IF  ( cont )  THEN
			    IF ( is1(21) .gt. 1 ) THEN
				CALL ST_INCH ( is1(21), tmpprm, ier )
				CALL ER_WMSG ( 'NDFDG2', -14, tmpprm, ier )
				cont = .false.
			    END IF
			END IF
C
C*	SECTION 2 - LOCAL SECTION
C                        
                       write_local = .false.       
			IF  ( cont )  THEN
			    IF ( is2(1) .ne. 0 ) THEN
			        write_local = .true.
				CALL ST_INCH ( is2(1), tmpprm, ier )
C				CALL ER_WMSG ( 'NDFDG2', -22, ' ', ier )
c				cont = .false.
			    END IF
			END IF

C
C*	SECTION 3 - GRID DEFINITION SECTION
C
C*	Source of grid definition (see Code Table 3.0 and Note 1)
C
			IF ( cont ) THEN
			    IF ( gds(6) .ne. 0 ) THEN
				CALL ST_INCH ( gds(6), tmpprm, ier )
				CALL ER_WMSG ( 'NDFDG2', -8, tmpprm, ier )
				cont = .false.
			    END IF
			END IF
C
C*	Grid Definition Template Number (see Code Table 3.1)
C
			IF ( cont ) THEN
			    CALL ND_GDS ( gds, gdsarr, iret )
			    jgrdnm = gds(13)
			    IF ( iret .ne. 0 )  THEN
				CALL ST_INCH ( jgrdnm, tmpprm, ier )
				CALL ER_WMSG ( 'NDFDG2', -4, tmpprm, ier )
				cont = .false.
			    END IF
			END IF
C
C*	SECTION 4 - PRODUCT DEFINITION SECTION
C
C*	Product Definition Template Number (see Code Table 4.0)
C
			IF ( cont ) THEN
			    CALL ND_PARM( is0(7), pds, parm, 
     +					  ihzrmp, idrct, iret)
     			    ighdr (1) = ihzrmp
			    ighdr (2) = idrct
			    IF ( iret .ne. 0 )  THEN       
			        IF (iret .eq. 4 ) THEN		        
			            WRITE(errmsg,1020) is0(7),  	
     +                                   pds(10), pds(11), pds(8)
     
 1020				    FORMAT ("DIS# =", i3, 1x, 
     +                           	    "CAT# =", i3, 1x, 
     +					    "ID# =",  i3, 1x, 
     +					    "PDT# =", i3)
                                ELSE
                                    errmsg = ' '
                                ENDIF
				CALL ER_WMSG ( 'NDFDG2', iret, errmsg,
     +							ier )
				cont = .false.
			    END IF
			END IF						
			IF ( cont ) THEN
			    jparm = pds(11)			    
			    CALL ND_FTIM ( is1, pds, jtime, jaccm, iret )
			    IF ( iret .ne. 0 ) THEN
				CALL ER_WMSG ( 'NDFDG2', iret, ' ', ier )
				cont = .false.
			    END IF
			END IF
						
			do 400 g = 1, num, 1
C			        write(*,*) gprmarr(g)
     			    IF (gprmarr(g) .eq. 'ALL' .or.
     +   			     gprmarr(g) .eq. ' ') then
			        cont = .true.
			        go to 401
			    ELSE
			        IF (gprmarr(g) .eq. parm) then 
			            cont = .true.
			            go to 401
			        ELSE
			            cont = .false.
			        END IF		   
			    END IF
 400                    continue	
 401			IF ( cont ) THEN
			    CALL TG_ITOC ( jtime, gdattm(1), ier )
			    gdattm(2) = ' '
C
C*	Type of first fixed surface (see Code Table 4.5)
C
			    jvcord = pds(23)
                            if ( jvcord .eq. 103) then
                              level(1) = pds(25)
                              level(2) = -1
                              CALL LV_CORD ( 'HGHT', vparm, ivcord, ier)
                            else if ( jvcord .eq. 0 ) THEN
                              CALL LV_CORD ( 'NONE', vparm, ivcord, ier)
                              level(1) = 0
                              level(2) = -1
			    else 
			      CALL ST_INCH ( jvcord, tmpprm, ier )
			      CALL ER_WMSG ( 'NDFDG2', +2, tmpprm, ier )
                               if(jvcord .ne. 0) then
				  cont = .false.
                               endif
			    END IF
			END IF
			
			IF ( cont ) THEN
C
C*	SECTION 5 - DATA REPRESENTATION SECTION
C
			    IF ( is5(6) .lt. 1 ) THEN
				CALL ER_WMSG ( 'NDFDG2', -23, tmpprm, ier )
				cont = .false.
			    END IF
			END IF
C
C*	SECTION 6 - BIT-MAP SECTION
C
			IF ( cont ) THEN
			    IF ( is6(6) .ne. 255 ) THEN
				CALL ER_WMSG ( 'NDFDG2', -18, tmpprm, ier )
				cont = .false.
			    END IF
			END IF
C
C*			List only or write the data to the GEMPAK file.
C
			IF  ( cont )  THEN
C
C*			Determine if the user only wants a LIST of the
C*			grids.
C
			    IF  ( lstflg )  THEN
C
C*			List the header information.
C
				knt = knt + 1
				prttl = .false.
				modknt = MOD(kntmsg,100)
				IF  ( knt .eq. 1 .or.
     +				      modknt .eq. 1 .or.
     +				      modknt .eq. 51 )
     +				        prttl = .true.
				    IF  ( nlun .ne. 0 )
     +					CALL GR_WGB2 ( lun, nlun, prttl,
     +						   kntmsg, gdattm, level,
     +						   ivcord, parm,
     +						   is0(7), pds(10), pds(11),
     +						   pds(8), jvcord,
     +						   jgrdnm, ier )
			    ELSE
				IF  ( igdfln .eq. 0 )  THEN
C
C*			Create/open the GEMPAK grid file, if necessary.
C
				    CALL ND_GCOG ( gdoutf, proj,
     +					  grdarea, kxky, cpyfil,
     +					  .false., garea, gdsarr, iskip,
     +					  maxg, igdfln, rnvblk, jgrdnm,
     +					  cprj, igx, igy, jx, jy,
     +					  ksbx, ksby, subset, iret )
				    IF  ( iret .ne. 0 )  THEN
					CALL ER_WMSG ( 'NDFDG2', iret,
     +							      ' ', ier )
					cont   = .false.
					proces = .false.
				    ELSE
					igxold = int ( rnvblk(5) )
				    END IF
				END IF
C
C*		Subset and skip as necessary, then write to the GEMPAK file.
C
				IF ( cont ) THEN
				    inx = igx
				    iny = igy
				    IF ( iskip .eq. 0 )  THEN
					IF ( .not. subset )  THEN
					    DO igpt = 1, inx*iny
					    IF (grid(igpt) .eq. 9999.0)
     +					  grid(igpt) = RMISSD
					    END DO
					ELSE
					    CALL ND_GSSG ( igxold, ksbx,
     +							 ksby, iskip,
     +							 grid, inx,
     +							 iny, iret )
					END IF
				    ELSE
				        IF ( .not. subset )  THEN
					    ksbx(1) = 1
					    ksbx(2) = inx
					    ksby(1) = 1
					    ksby(2) = iny
					END IF
					 CALL ND_GSSG ( igxold, ksbx, ksby,
     +					      iskip, grid, inx, iny, iret )
				    END IF
				END IF
				IF  ( cont )  THEN
				    nbits = is5(20) + 2
				    CALL GD_WPGD ( igdfln,
     +						grid, inx, iny,
     +						ighdr, gdattm,
     +						level, ivcord,
     +						parm, .false.,
     +						MDGGRB, nbits,
     +						ierr )
				    IF  ( ierr .eq. 0 )  THEN
					knt = knt + 1
					prttl = .false.
					modknt=MOD(kntmsg,100)       
					IF  ( knt .eq. 1 .or.
     +					      modknt .eq. 1.or.
     +					      modknt .eq. 51 )
     +					      prttl = .true.
					CALL GR_WGB2 ( lun,
     +						nlun, prttl,
     +						kntmsg, gdattm, level,
     +						ivcord, parm,
     +						is0(7), pds(10), pds(11), 
     +						pds(8), jvcord,
     +						jgrdnm, ier )
     
     					IF ( write_local ) then 				    
     					    CALL ND_WLCL(idat, gdattm,
     +						iret )     
     					ENDIF
     				    ELSE
					CALL ER_WMSG ( 'GD', ierr,
     +							' ', ier )
					IF ( ierr .eq. -11 )
     +					    proces = .false.
				    END IF
				END IF
			    END IF
			END IF
		    END IF
		END DO
		
C
C*		Write the output information to the luns.
C
		IF ( nlun .gt. 0 )  THEN
C
		    DO  ii = 1, nlun
C
			ilun = lun(ii)
C
			IF ( proces )  THEN
			    WRITE ( ilun, 1000 ) kntmsg
			ELSE
			    WRITE ( ilun, 1000 ) MAX(0,kntmsg-1)
			END IF
			WRITE ( ilun, 1001 ) gbfile
			IF  ( .not. lstflg )  THEN
			    WRITE ( ilun, 1010 ) knt
			    WRITE ( ilun, 1001 ) gdoutf
			END IF
C
		    END DO
C
		END IF
C
1000		FORMAT ( // 5X, I5,
     +		' GRIB messages were read or scanned from the',
     +		' GRIB file:' )
1001		FORMAT ( 5X, A72 / )
1010		FORMAT ( 5X, I5,
     +			' grids were written to the GEMPAK file:' )
C
C*		Update parameter values, display grid info 
C*		and close the files.
C
		IF  ( igdfln .ne. 0 )  THEN
C
		    CALL GD_CLOS ( igdfln, ier2 )
C
		    IF ( nlun .ne. 0 )  
     +			CALL GD_GENI ( gdoutf, nlun, lun, ier )
C
		END IF
C
		CALL GB_CLOS ( ier2 )
C
	    END IF
C
C*	    Call dynamic tutor.
C
	    CALL IP_DYNM ( done, ier )
C
	END DO
C
C*	Final error messages.
C
	IF  ( iperr .ne. 0 )  CALL ER_WMSG ( 'NDFDG2', iperr, ' ', ier )
	CALL IP_EXIT ( iret )
C
	END

	SUBROUTINE ND_GANL  ( anlyss, rnvblk, anlblk, iret )
C************************************************************************
C* ND_GANL								*
C*									*
C* This subroutine takes the user input for ANLYSS (the analysis 	*
C* information) and makes a grid analysis block.  The grid navigation	*
C* is first set in GR_SNAV.						*
C*									*
C* ND_GANL  ( ANLYSS, RNVBLK, ANLBLK, IRET )				*
C*									*
C* Input parameters:							*
C*	ANLYSS		CHAR*		User input for ANLYSS		*
C*      RNVBLK (*)      REAL		Grid navigation block		*
C*									*
C* Output parameters:							*
C*	ANLBLK (18)	REAL		Grid analysis block		*
C*	IRET		INTEGER		Return code			*
C*					  0 = normal return		*
C*                                       -4 = invalid navigation	*
C*					-10 = invalid extend region	*
C**									*
C* Log:									*
C* S. Jacobs/EAI	 7/93		Copied from GDCANL		*
C************************************************************************
	INCLUDE		'GEMPRM.PRM'
C*
	CHARACTER*(*)	anlyss
	REAL		rnvblk (*), anlblk (*)
C*
	REAL		dbnds  (4)
	INTEGER		iebnds (4)
	CHARACTER       stusr (2)*48
C------------------------------------------------------------------------
	iret = 0
C
C*      Separate user input into two substrings.
C
	CALL ST_CLST ( anlyss, '/', ' ', 2, stusr, n, ier )
C
C*	Extract DELTAN from the first substring.
C
	CALL ST_CRNM ( stusr (1), deltan, ier )
C
C*	Extract extend region from the second substring.
C
	CALL ST_ILST ( stusr (2), ';', 2, 4, iebnds, n, ier )
C
C*	Set default data area to missing.
C
	DO  i = 1, 4
	    dbnds (i) = RMISSD
	END DO
C
C*	Make an analysis block.
C
	CALL GR_MBN2  ( deltan, iebnds, dbnds, rnvblk, anlblk, ier )
C*
	RETURN
	END

	SUBROUTINE ND_GSSG ( igxold, ksbx, ksby, iskip, grid, 
     +							igx, igy, iret )
C************************************************************************
C* ND_GSSG								*
C*									*
C* This subroutine subsets and applies a skip factor to a grid using 	*
C* the subset coordinates in KSBX and KSBY and the skip factor in ISKIP.*
C* The new grid dimensions are returned in IGX and IGY.			*
C*									*
C* ND_GSSG ( IGXOLD, KSBX, KSBY, ISKIP, GRID, IGX, IGY, IRET )		*
C*									*
C* Input parameters:							*
C*	IGXOLD  	INTEGER		Maximum grid size    		*
C*	KSBX (2)	INTEGER		Subset X coordinates		*
C*	KSBY (2)	INTEGER		Subset Y coordinates		*
C*	ISKIP		INTEGER		Skip factor ( 0 = no skip )	*
C*									*
C* Input and output parameters:						*
C*	GRID (*)	REAL		Grid of data			*
C*	IGX		INTEGER		New X grid dimension		*
C*									*
C* Output parameters:							*
C*	IGY		INTEGER		New Y grid dimension		*
C*	IRET		INTEGER		Return code			*
C*					  0 = Normal			*
C*									*
C**									*
C* Log:									*
C* T. Piper/SAIC	10/02	Modified from NAGSSG for GRIB2		*
C* T. Piper/SAIC	04/03	Added skip factor			*
C************************************************************************
	INCLUDE		'GEMPRM.PRM'
C*
	REAL		grid(*)
	INTEGER		ksbx(2), ksby(2)
C*
C------------------------------------------------------------------------
	io = 0
	iret = 0
	jskip = iskip + 1
	DO j = ksby(1), ksby(2), jskip
	    DO i = ksbx(1), ksbx(2), jskip
		k = i
		IF ( k .gt. igxold ) k = k - igxold
		indx = ( j - 1 ) * igx + k
		io = io + 1
		IF ( grid(indx) .eq. 9999.0 ) THEN
		    grid(io) = RMISSD
		ELSE
		    grid(io) = grid(indx)
		END IF
	    END DO
	END DO
        igx = ((ksbx(2) - ksbx(1))/jskip) + 1
        igy = ((ksby(2) - ksby(1))/jskip) + 1
C*
	RETURN
	END

	SUBROUTINE ND_GCOG ( gdoutf, proj, grdarea, kxky, cpyfil,
     +			    fill, garea, gdsarr, iskip, maxg, igdfln, 
     +			    rnvful, igrdnm, cprj, ikx, iky, jx, jy, 
     +			    ksubx, ksuby, subset, iret )
C************************************************************************
C* ND_GCOG								*
C*									*
C* This routine will create a new GEMPAK grid file, or open an 		*
C* existing file.							*
C*									*
C* ND_GCOG ( GDOUTF, PROJ, GRDAREA, KXKY, CPYFIL, FILL, GAREA, GDSARR,	*
C*	    ISKIP, MAXG, IGDFLN, RNVFUL, IGRDNM, CPRJ, IKX, IKY, JX, 	*
C*	    JY,	KSUBX, KSUBY, SUBSET, IRET )				*
C*									*
C* Input parameters:							*
C*	GDOUTF		CHAR*		GEMPAK output grid file		*
C*	PROJ		CHAR*		Projection of grid to create	*
C*	GRDAREA		CHAR*		Grid area of grid to create	*
C*	KXKY		CHAR*		Number of points for grid	*
C*	CPYFIL		CHAR*		File or table number to copy	*
C*					   for navigation info		*
C*	FILL		LOGICAL		Fill flag			*
C*	GAREA		CHAR*		Grid subset area		*
C*	GDSARR (10)	REAL		GDS projection information	*
C*	ISKIP		INTEGER		Number of points to skip	*
C*									*
C* Input/output parameters:						*
C*	MAXG		INTEGER		Max number of grids for file	*
C*									*
C* Output parameters:							*
C*	IGDFLN		INTEGER		Output grid file number		*
C*	RNVFUL (*)	REAL		Navigation block for full grid	*
C*	IGRDNM		INTEGER		Navigation number from table	*
C*	CPRJ		CHAR*		Projection of the grid		*
C*	IKX		INTEGER		Number of points in X-direction	*
C*	IKY		INTEGER		Number of points in Y-direction	*
C*	JX		INTEGER		Number of X pts on filled grid	*
C*	JY		INTEGER		Number of Y pts on filled grid	*
C*	KSUBX (2)	INTEGER		Subset range in X-direction	*
C*	KSUBY (2)	INTEGER		Subset range in Y-direction	*
C*	SUBSET		LOGICAL		Subset flag			*
C*	IRET		INTEGER		Return code			*
C*						-10 GDOUTF = ' '	*
C*						-11 Error opening file	*
C*						-12 Error creating file	*
C*									*
C**									*
C* Log:									*
C* T. Piper/SAIC	04/03	Modified from NAGCOG 			*
C************************************************************************
	INCLUDE		'GEMPRM.PRM'
C*
	CHARACTER*(*)	gdoutf, proj, grdarea, kxky, cpyfil, cprj,
     +			garea
	REAL		rnvful(*), gdsarr(*)
	INTEGER		ksubx(2), ksuby(2)
	LOGICAL		fill, subset
C*
	CHARACTER	cpytmp*72, name*4, newfil*132
	REAL		anlblk(LLNANL), rnvtst(LLNNAV),
     +			anltst(LLNANL), altln(4), rnvblk(LLNNAV)
	LOGICAL		exist, gsflag
	DATA		anlblk / LLNANL * 0 /
C------------------------------------------------------------------------
	iret = 0
C
C*	If the output file is blank, return.
C
	IF  ( gdoutf .eq. ' ' )  THEN
	    iret = -10
	    RETURN
	END IF
C
C*	Check for the existence of the output file. If it exists, open
C*	it, if not, create it.
C
	CALL FL_INQR ( gdoutf, exist, newfil, ier )
	IF  ( exist )  THEN
	    WRITE ( 6, * ) 'Opening the GEMPAK grid file'
	    CALL GD_OPNF ( gdoutf, .true., igdfln, inav, rnvblk,
     +			   ianl, anlblk, ihdsz, maxg, iret )
	    IF  ( iret .ne. 0 )  THEN
		iret = -11
		RETURN
	    END IF
C
C*	    Check the navigation information against the GRIB info.
C
	    CALL ST_LCUC ( cpyfil, cpytmp, ier )
	    IF  ( cpyfil .eq. ' ' )  THEN
C
C*	    	CASE 1: Get navigation block from the user input.
C
		CALL ND_GNAV ( proj, kxky, grdarea, cprj, ikx, iky,
     +			      altln, rnvful, ierr )
		IF  ( ierr .ne. 0 )  THEN
		    iret = -11
		    RETURN
		END IF
	    ELSE IF  ( cpyfil(1:1) .eq. '#' )  THEN
C
C*	    	CASE 2: Get navigation block from the grid
C*			navigation table input.
C
		CALL ND_GTBL ( cpyfil, name, cprj, ikx, iky, altln,
     +			      rnvful, anltst, ierr )
		IF  ( ierr .ne. 0 )  THEN
		    iret = -11
		    RETURN
		END IF
		CALL ST_NUMB ( cpyfil(2:), igrdnm, ier )
	    ELSE IF  ( cpytmp .eq. 'GDS' )  THEN
C
C*	    	CASE 3: Get navigation block from the GDS information.
C
		IF ( fill .and. gdsarr (2) + gdsarr (3) .eq. 0. ) THEN
		    iret = -21
		    RETURN
		END IF
		CALL ND_GGDS ( gdsarr, cprj, ikx, iky, altln, rnvful,
     +			      ierr )
		IF  ( ierr .ne. 0 )  THEN
		    iret = -11
		    RETURN
		END IF
	    END IF
	    DO ii = 1, LLNNAV
		rnvtst(ii) = rnvful(ii)
	    END DO
	    CALL GR_SUBA ( garea, fill, rnvtst, altln, ksubx, ksuby,
     +			  subset, iret )
	    IF ( iret .ne. 0 ) RETURN
            IF ( iskip .gt. 0 )  THEN 
		IF ( ( rnvtst(5) / iskip ) .le. 4 .OR.
     +			( rnvtst(6) / iskip ) .le. 4 ) THEN
		    iret = -24
		    RETURN
		ELSE
                    rnvtst(5) = rnvtst(5) / (iskip + 1)
                    rnvtst(6) = rnvtst(6) / (iskip + 1)
		END IF
            END IF  
	    CALL GR_CNAV ( rnvblk, rnvtst, LLNNAV, gsflag, ier )
	    IF  ( .not. gsflag )  THEN
		iret = -11
		RETURN
	    END IF
	ELSE
C
C*	    Create a new file by one of the methods below.
C
	    WRITE ( 6, * ) 'Creating the GEMPAK grid file...'
	    ihd = 10
	    CALL ST_LCUC ( cpyfil, cpytmp, ier )
	    IF  ( cpyfil .eq. ' ' )  THEN
C
C*	    	CASE 1: Build new navigation block from the user input.
C
		CALL ND_GNAV ( proj, kxky, grdarea, cprj, ikx, iky,
     +			      altln, rnvful, ierr )
		IF  ( ierr .eq. 0 )
     +		    CALL ND_GANL ( '4/0;0;0;0', rnvful, anlblk, ierr )
		IF  ( ierr .ne. 0 )  THEN
		    iret = -12
		    RETURN
		END IF
	    ELSE IF  ( cpyfil(1:1) .eq. '#' )  THEN
C
C*	    	CASE 2: Build new navigation and analysis blocks from
C*			the grid navigation table input.
C
		CALL ND_GTBL ( cpyfil, name, cprj, ikx, iky, altln,
     +			      rnvful, anlblk, ierr )
		IF  ( ierr .ne. 0 )  THEN
		    iret = -12
		    RETURN
		END IF
		CALL ST_NUMB ( cpyfil(2:), igrdnm, ier )
	    ELSE IF  ( cpytmp .eq. 'GDS' )  THEN
C
C*	    	CASE 3: Build new navigation block from the GDS
C*			information.
C
		IF ( fill .and. gdsarr (2) + gdsarr (3) .eq. 0. ) THEN
		    iret = -21
		    RETURN
		END IF
		CALL ND_GGDS ( gdsarr, cprj, ikx, iky, altln, rnvful,
     +			      ierr )
		IF  ( ierr .eq. 0 )
     +		    CALL ND_GANL ( '4/0;0;0;0', rnvful, anlblk, ierr )
		IF  ( ierr .ne. 0 )  THEN
		    iret = -12
		    RETURN
		END IF
	    ELSE
C
C*	    	CASE 4: Get navigation and analysis blocks from the
C*			old file.
C
		CALL GD_OPNF ( cpyfil, .false., iflno, inav, rnvful,
     +			       ianl, anlblk, ihd, imxgd, ierr )
		IF  ( ierr .ne. 0 )  THEN
		    iret = -12
		    RETURN
		END IF
		CALL GD_CLOS ( iflno, ier )
		CALL GR_RNAV ( rnvful, cprj, ikx, iky, ier )
		altln(1) = rnvful(7)
		altln(2) = rnvful(8)
		altln(3) = rnvful(9)
		altln(4) = rnvful(10)
	    END IF
C
C*	    Check that the output filename is not blank.
C
	    IF  ( gdoutf .eq. ' ' )  THEN
		iret = -7
		RETURN
	    END IF
C
C*	    Create the file.
C
	    DO ii = 1, LLNNAV
		rnvblk (ii) = rnvful (ii)
	    END DO
	    CALL GR_SUBA ( garea, fill, rnvblk, altln, ksubx, ksuby,
     +			  subset, iret )
	    IF ( iret .ne. 0 ) RETURN
	    IF ( iskip .gt. 0 )  THEN
		IF ( ( rnvblk(5) / iskip ) .le. 4 .OR.
     +			( rnvblk(6) / iskip ) .le. 4 ) THEN
		    iret = -24
		    RETURN
		ELSE
		    rnvblk(5) = rnvblk(5) / (iskip + 1)
		    rnvblk(6) = rnvblk(6) / (iskip + 1)
		END IF            
	    END IF
	    igszch = NINT ( rnvblk(5) ) * NINT ( rnvblk(6) )
	    IF ( igszch .gt. LLMXTG ) THEN
		iret = -21
		RETURN
	    END IF
	    CALL GD_CREF ( gdoutf, LLNNAV, rnvblk, LLNANL, anlblk,
     +			   ihd, maxg, igdfln, ierr )
	    IF  ( ierr .ne. 0 )  THEN
		iret = -12
		RETURN
	    END IF
	END IF
C
C*	If necessary, get dimensions of staggered grid.
C
	IF ( fill ) THEN
	    CALL GR_RNAV ( rnvful, name, jx, jy, ier )
	    jx = ( jx + 1 ) / 2
	END IF
	WRITE ( 6, * ) 'GEMPAK grid file is ready...'
C*
	RETURN
	END

	SUBROUTINE ND_GNAV  ( proj, kxky, gdarea, cprj, kx, ky,  
     +			     grdout, rnvblk, iret )
C************************************************************************
C* ND_GNAV								*
C*									*
C* This subroutine takes the user input for PROJ and KXKY and 		*
C* makes a grid navigation block.    					*
C*									*
C* ND_GNAV  ( PROJ, KXKY, GDAREA, CPRJ, KX, KY, GRDOUT, RNVBLK, IRET )	*
C*									*
C* Input parameters:							*
C*	PROJ		CHAR*		User input for PROJ		*
C*	KXKY		CHAR*		User input for KXKY		*
C*	GDAREA		CHAR*		User input for GDAREA		*
C*									*
C* Output parameters:							*
C*	CPRJ		CHAR*		Grid projection			*
C*	KX		INTEGER		Number of points in x dir	*
C*	KY		INTEGER		Number of points in y dir	*
C*	GRDOUT  (4)	REAL		Grid corners			*
C*	RNVBLK  (13)	REAL		Grid navigation block		*
C*	IRET		INTEGER		Return code			*
C*					  0 = normal return		*
C*					 -4 = invalid navigation	*
C*					 -5 = invalid grid area		*
C*					 -6 = invalid grid size		*
C**									*
C* Log:									*
C* S. Jacobs/EAI	 7/93	Copied from GDCNAV			*
C* G. Krueger/EAI	 6/96	Add default projection			*
C************************************************************************
	CHARACTER*(*)	proj, kxky, gdarea, cprj
	REAL		rnvblk (*)
C*
	CHARACTER	cdproj*30
	REAL		zmarg (4), rarr (2), rltln (4), grdout (4),
     +			angle (3), centrd (2)
	INTEGER		iarr  (2)
	LOGICAL		angflg, space
C------------------------------------------------------------------------
	iret = 0
C
C*	Translate grid projection information.
C
	CALL GG_PROJ  ( proj, cprj, angle, zmarg, angflg, ier )
	angle1 = angle (1)
	angle2 = angle (2)
	angle3 = angle (3)
C
C*	Check for error.
C
	IF  ( ier .ne. 0 )  THEN
	    CALL ER_WMSG  ( 'GG', ier, proj, ier1 )
	    iret = -4
	    RETURN
	END IF
C
C*	Translate grid area.
C
	CALL LC_GARE  ( gdarea, rltln, cdproj, centrd, ier )
	IF  ( ier .ne. 0 )  THEN
	    iret = -5
	    CALL ER_WMSG  ( 'NAGRIB', iret, gdarea, ier )
	    RETURN
	END IF
C
C*	Translate the input for KXKY.
C
	IF  ( ( cprj .eq. 'CED' ) .and. ( kxky (1:1) .eq. '#' ) )  THEN
	    space = .true.
	  ELSE
	    space = .false.
	END IF
C
C*	Check for input as grid spacing.
C
	IF  ( space )  THEN
C
C*	    Get x- and y- spacing and check that there are two numbers.
C
	    CALL ST_RLST  ( kxky (2: ), ';', 0., 2, rarr, num, ier )
	    IF  ( ( rarr (1) .le. 0. ) .or. ( rarr (2) .le. 0. ) )  THEN
		iret = -6
		CALL ER_WMSG  ( 'NAGRIB', iret, ' ', ier )
		RETURN
	      ELSE
		xspace = rarr (1)
		yspace = rarr (2)
	    END IF
C
C*	    Align on grid points and exit for error.
C
	    CALL GR_ALGN ( rltln, xspace, yspace, grdout, kx, ky, iret )
	    IF  ( iret .ne. 0 )  THEN
		CALL ER_WMSG  ( 'GR', iret, ' ', ier )
		iret = -4
		RETURN
	    END IF
C
C*	    Otherwise, find kx, ky.
C
	  ELSE
	    DO  i = 1, 4
		grdout (i) = rltln (i)
	    END DO
C
C*	    Get two numbers and check for error.
C
	    CALL ST_ILST  ( kxky, ';', 0, 2, iarr, num, ier )
	    kx = iarr (1)
	    ky = iarr (2)
	    IF  ( ( kx .lt. 2 ) .or. ( ky .lt. 2 ) )  THEN
		iret = -6
		CALL ER_WMSG  ( 'NAGRIB', iret, ' ', ier )
		RETURN
	    END IF
	END IF
C
C*	Fill navigation block.
C
	CALL GR_MNAV  ( cprj, kx, ky, grdout (1), grdout (2),
     +			grdout (3), grdout (4), angle1, angle2,
     +			angle3, angflg, rnvblk, ier )
C*
	RETURN
	END
